/*
 * Initializes the Big Struct
 *
 */

#include "sim.h"

int dspinit(void)
{
  /* we wipe the DSP in its entirety with a single memset... */
  memset(&curdsp, 0x00, sizeof(struct dsp_s));

  irq_initsingle(&curdsp.irqs[0], "Reset", 0x0000);
  irq_initsingle(&curdsp.irqs[1], "Powerdown", 0x002c);
  irq_initsingle(&curdsp.irqs[2], "/IRQ2", 0x0004);
  irq_initsingle(&curdsp.irqs[3], "/IRQL1", 0x0008);
  irq_initsingle(&curdsp.irqs[4], "/IRQL0", 0x000c);
  irq_initsingle(&curdsp.irqs[5], "SPORT0 Tx", 0x0010);
  irq_initsingle(&curdsp.irqs[6], "SPORT0 Rx", 0x0014);
  irq_initsingle(&curdsp.irqs[7], "/IRQE", 0x0018);
  irq_initsingle(&curdsp.irqs[8], "BDMA", 0x001c);
  irq_initsingle(&curdsp.irqs[9], "SPORT1 Tx, /IRQ1", 0x0020);
  irq_initsingle(&curdsp.irqs[10], "SPORT1 Rx, /IRQ0", 0x0024);
  irq_initsingle(&curdsp.irqs[11], "Timer", 0x0028);

  set_sstat(0x55); /* mark PC/Count/Status/Loop stacks empty */

  reg_flipset(0); /* switch to primary registers */
  set_dmovlay(1); /* use primary lower data page */

  return 0;
}

void init_softreboot(void)
{
  fprintf(stderr, "init_softreboot: Starting soft reboot...\n");

  /* 
   * FIXME: reset the other things that need reset...not real sure
   * what they are... see Pg 9-11. 
   */

  pc_zero();
  state_zero();
  count_zero();
  loop_zero();
  curdsp.sequencer.imask = 0;
  curdsp.sequencer.astat = 0;
  curdsp.sequencer.sstat = 0x55;
  curdsp.sequencer.ifc = 0x00;

  curdsp.sequencer.pc = 0x3fff; /* this gets incremented to 0x0000 */
  fprintf(stderr, "init_softreboot: Reboot complete.  PC set to 0x0000\n");
  return;
}
